<?php
/**
 * @author bronco@warriordudimanche.com
 * @copyright open source and free to adapt (keep me aware !)
 * @version 0.21
 *   auto_form.php is a little script to auto create a form and 
 *   its content only with an array. 
 *	 It can create text inputs radiobuttons, select lists, passwords inputs. 
 * 	 All the generated form's elements can be reached by classes 
 *	 and ids with css or jquery.
 *
 *	 It's possible to configure auto_form to add some features
 * 	 like placeholders, labels etc.
*/


/* this is an example array
$config=array(
	'use_a_boolean_value'=>true,
	'allow_user_to_config'=>false,
	'adresse_du_site'=>'www.warriordudimanche.net',
	'use_a_choice'=>'choice one',// current value: other values are defined below
	'use_a_radiobutton_choice'=>'choice one',// current value: other values are defined below
	'my_password'=>'password',
	'confirm_password'=>'',
	
);*/
//then render_form($config);


/* #####################################################################
   # auto_form config                                                  #
   #####################################################################
   
*/

// here are the basic parameters
$autoform=array(
	'use_labels'=>true,
	'use_placeholder'=>false,
	'surrounding_object'=>'li', // the object that surrounds each form's element 
	'method'=>'post',
	'action'=>'auto_form2file.php',
	'form_name'=>'autoform',
	'form_id'=>'autoform',
	'form_class'=>'autoform',
	'enctype'=>'',
	'submit_button_label'=>'Envoyer',
	'reset_button_label'
);
// -------------------------------------------------------------------------------------------------------
// you can set specific attributes to specific keys of your data array
// note: it's possible to configure this outside auto_form, just before calling the render_form function
// -------------------------------------------------------------------------------------------------------
// use $autoform['the key you want to customize'][type] to force the type
// use $autoform['the key you want to customize'][class] to add classes
// use $autoform['the key you want to customize'][placeholder] to add a placeholder (default value, the key name) if specified, it overcomes the $autoform['use_placheholder']=false
// use $autoform['the key you want to customize'][required]=true to force the required attribute
// use $autoform['the key you want to customize'][autocomplete]=true/"off" to force the autocomplete attribute to off
// use $autoform['the key you want to customize'][spellcheck]=true to force the spellcheck attribute
// use $autoform['the key you want to customize'][autofocus]=true to force the autofocus attribute
// use $autoform['the key you want to customize'][disabled]=true to force the disabled attribute
// use $autoform['the key you want to customize'][readonly ]=true to force the readonly  attribute
// use $autoform['the key you want to customize'][list]=array('item 1','item 2 ' etc ); to create a list of values ([type]=radio or select)
// use $autoform['the key you want to customize'][max]=50; sets the max attribute for type=number
// use $autoform['the key you want to customize'][min]=50; sets the min attribute for type=number
// use $autoform['the key you want to customize'][step]=10; sets the step attribute for type=number
// -------------------------------------------------------------------------------------------------------

$autoform['use_a_choice']['list']=array('choice one','choice two','choice three');// here we define the other possible values => oh, ok : that's a select input !
$autoform['use_a_radiobutton_choice']['list']=array('choice one','choice two','choice three');// here we define the other possible values => oh, ok : that's a select input !
$autoform['use_a_radiobutton_choice']['type']='radio';// here we force the list to appear as a radiobutton list
$autoform['my_password']['type']='password';// here we force the input's type to password
$autoform['my_password']['required']=true;
$autoform['my_password']['class']='red';
$autoform['adresse_du_site']['type']='url';// force the type
$autoform['email']['type']='email';
$autoform['telephone']['type']='tel';// force the type
$autoform['date']['type']='date';
$autoform['time']['type']='time';

$autoform['text']['type']='textarea';





/* #####################################################################
   # the render function                                               #
   #####################################################################
   You can call it from anywhere in the page and render more than one form
   just call render_form($data_array)to create a brand new form with differents
   names, classes, ids etc.
*/
function noquotes($txt){return str_replace(array('"',"'"),'',$txt);}
function render_form($var){
	global $autoform;$all_keys='';
	$id=$class=$enctype=$reset=$form='';
	if ($autoform['form_id']){$id=' id="'.$autoform['form_id'].'" ';}
	if ($autoform['form_class']){$class=' class="'.$autoform['form_class'].'" ';}
	if ($autoform['enctype']){$enctype=' enctype="'.$autoform['enctype'].'" ';}
	if (isset($autoform['reset_button_label'])){$reset="<input type='reset' value='".$autoform['reset_button_label'].'"/>';}
	
	$form.= '<form name="'.$autoform['form_name']."\" $id $class $enctype method=\"".$autoform['method']."\" action=\"".$autoform['action']."\">\n ";
		foreach($var as $key=>$value){

			$all_keys.=$key.' | ';
			$txt=str_replace('_',' ',$key);
			$spellcheck=$required=$autofocus=$autocomplete=$disabled=$readonly=$placeholder='';
			$idname="name='$key' id='$key'";
			if (!empty($autoform[$key]['spellcheck'])){$spellcheck=' spellcheck="true" ';}
			if (!empty($autoform[$key]['required'])){$required=' required ';}
			if (!empty($autoform[$key]['autofocus'])){$autofocus=' autofocus ';}
			if (!empty($autoform[$key]['autocomplete'])){$autocomplete=' autocomplete="off" ';}
			if (!empty($autoform[$key]['disabled'])){$disabled=' disabled ';}
			if (!empty($autoform[$key]['readonly'])){$readonly=' readonly ';}
			if (!empty($autoform[$key]['class'])){$class=' class="'.$autoform[$key]['class'].' '.$key.'" ';}else {$class=" class='$key' ";}			
			if (!empty($autoform[$key]['placeholder'])){
				$placeholder=' placeholder="'.$autoform[$key]['placeholder'].'"';
			}else{
				if ($autoform['use_placeholder']){
					$placeholder=' placeholder="'.$txt.'" ';
				}
			}

			$attr=$placeholder.$required.$disabled.$autofocus.$spellcheck.$autocomplete.$readonly.$class;

			$form.= '<'.$autoform['surrounding_object'].'>';
			if (is_bool($value)){ 
				// oh, a checkbox !				
				if ($value==true){$checked=' checked ';}else{$checked='';}
				$form.= "<label class='$key checkbox' for='$key'>$txt</label>";
				$form.= "<input type='checkbox' $idname $attr $checked value=true />";
			}
			else{			
				$value=stripslashes($value);
				if (isset($autoform[$key]['list'])&&is_array($autoform[$key]['list'])){
					// lists of choices
					if (isset($autoform[$key]['type'])&&$autoform[$key]['type']=='radio'){
						// oh, a radiobutton list !
						$form.= $txt;
						$form.= "<ul>\n";
						foreach ($autoform[$key]['list'] as $chkey=>$choice){
							if ($choice==$value){$checked='checked';}else{$checked='';}
								$form.= "<li><label for='$choice$key' class='radio $choice'> $choice </label><input name='$key' type='radio' value='$choice' $attr $checked id='$choice$key'/></li>\n";
							}
						$form.= "</ul>\n";
						
					}else{
						// oh, a select input !
						$form.="<label class='$key select' for='$key'>$txt</label>";
						$form.= "<select $idname text='".str_replace('"','',$value)."' $attr >\n";						
						foreach ($autoform[$key]['list'] as $choice){
							if ($choice==$value){$checked='selected';}else{$checked='';}
							$form.= "<option $checked value='$choice'>$choice</option>\n";
						}
						$form.= "</select>\n";
					}

				}else if (isset($autoform[$key]['type']) && $autoform[$key]['type']=='textarea'){
					//oh, a textarea !
					if ($autoform['use_labels']){$form.= "<label class='$key textarea' for='$key'>$txt</label>";}
					$form.= "<textarea $idname $attr >$value</textarea>\n"; 

				}else if (isset($autoform[$key]['type'])){
					//oh, a specific input !
					$max=$min=$step='';
					if ($autoform['use_labels']){$form.='<label class="'.$key.' '.$autoform[$key]['type'].'"  for="'.$key.'">'.$txt.'</label>';}
					if (isset($autoform[$key]['max'])){$max=' max="'.$autoform[$key]['max'].'" ';}
					if (isset($autoform[$key]['min'])){$min=' min="'.$autoform[$key]['min'].'" ';}
					if (isset($autoform[$key]['step'])){$step=' step="'.$autoform[$key]['step'].'" ';}
					$form.= '<input type="'.$autoform[$key]['type'].'" '.$idname.$attr.$max.$min.$step.'value="'.noquotes($value)."\" />\n"; 

				}else{
					// ok, so that's a text input... (by default)
					if ($autoform['use_labels']){$form.= "<label class='$key text' for='$key'>$txt</label>";}
					$form.= "<input type='text' $idname $attr value='".noquotes($value)."'/>\n"; 				
				}
			}
			$form.= '</'.$autoform['surrounding_object'].">\n";
		}
	$form.= "<input type='hidden' name='all_keys' value='$all_keys'/>\n";// this line to prevent unchecked boxes to desapear.
	$form.= '<input type="submit" value="'.$autoform['submit_button_label']."\"/> $reset \n </form>";
	return $form;
}
?>